#include "elevated.h"
#include <common/exception.h>
#include <common/build.h>
#include <alg/device.h>

#include <unistd.h>
#include <errno.h>
#include <string.h>

using namespace bdk;


ElevatedScope::ElevatedScope()
{
	BCDeviceHandle dev = BCDevice::get_free();
	m_uid = getuid();
	dev->elevate();
	setuid(0);

#ifdef BC_DEBUG
	uid_t ruid, euid, suid;
	getresuid(&ruid, &euid, &suid);
	BC_DEBUG_PRINT(("Debug: elevation enter: ruid %d, euid %d, suid %d\n", ruid, euid, suid));
#endif
}

ElevatedScope::ElevatedScope(BCDeviceHandle dev)
{
	m_uid = getuid();
	dev->elevate();
	setuid(0);

#ifdef BC_DEBUG
	uid_t ruid, euid, suid;
	getresuid(&ruid, &euid, &suid);
	BC_DEBUG_PRINT(("Debug: elevation enter: ruid %d, euid %d, suid %d\n", ruid, euid, suid));
#endif
}


ElevatedScope::~ElevatedScope()
{
	setuid( m_uid );
#ifdef BC_DEBUG
	uid_t ruid, euid, suid;
	getresuid(&ruid, &euid, &suid);
	BC_DEBUG_PRINT(("Debug: elevation exit: ruid %d, euid %d, suid %d\n", ruid, euid, suid));
#endif
}


