#ifndef BC_LINUX_ELEVATED_H
#define BC_LINUX_ELEVATED_H

#include <sys/types.h>

#include <common/class_defs.h>
#include <alg/device.h>


/**
 * @brief Linux elevated scope
 *
 * Elevates suid program for object lifetime
 */
class ElevatedScope
{
BC_FORBID_COPY(ElevatedScope)
public:


	ElevatedScope();


	/**
	 * @brief Elevate priveledges to saved-uid level
	 *
	 * Will throw CBCException if elevation failed
	 */
	explicit ElevatedScope(bdk::BCDeviceHandle);


	/**
	 * @brief Drop priveledges to real-uid level
	 */
	~ElevatedScope();


private:


	/* saved uid */
	uid_t m_uid;

};


#endif
