#ifndef BC_LINUX_PROCESS_H
#define BC_LINUX_PROCESS_H

#include <string>
#include <vector>

class Process
{
public:


	/**
	 * @brief	Init process
	 */
	Process(std::string const & objname) : m_name(objname)
	{
	}


	/**
	 * @brief	Execute process.
	 *
	 * @p args	Argument list.
	 *
	 * @return	System return code.
	 */
	int exec(std::vector < std::string > args);


private:


	std::string m_name;
};


#endif
